/*****************************************************************************
;  :Module.	wincust.c
;  :Author.	Bert Jahn
;  :EMail.	jah@fh-zwickau.de
;  :Address.	Franz-Liszt-Strae 16, Rudolstadt, 07404, Germany
;  :Version.	$Id: wincust.c 0.3 2000/06/04 20:55:21 jah Exp $
;  :History.	18.07.98 started
;  :Copyright.	All Rights Reserved
;  :Language.	C
;  :Translator.	GCC
*****************************************************************************/

#include <libraries/mui.h>

#include <clib/alib_protos.h>
#include <clib/muimaster_protos.h>

#include "whddump.h"
#include "WHDLoadGCI.h"

/****************************************************************************/

extern APTR			app,win;
extern struct whddump_custom	*custom;
extern const char		*StringHexAccept;
extern struct Library		*MUIMasterBase;

/****************************************************************************/

APTR win_cust = NULL;

/****************************************************************************/

void make_win_cust(void) {
	ULONG open;
	APTR
		c_vhpos,c_joy0dat,c_joy1dat,c_adkcon,c_pot0dat,c_pot1dat,c_potgo,c_joytest,c_serdat,c_serper,c_dskbyt,c_dskpt,c_dsklen,c_dsksync,
		c_copcon,c_cop1lc,c_cop2lc,c_copjmp1,c_copjmp2,
		c_bltcon0,c_bltcon1,c_bltafwm,c_bltalwm,c_bltapt,c_bltbpt,c_bltcpt,c_bltdpt,
		c_diwstrt,c_diwstop,c_ddfstrt,c_ddfstop,
		c_bltamod,c_bltbmod,c_bltcmod,c_bltdmod,c_bltadat,c_bltbdat,c_bltcdat,c_bltsize,c_bltsizv,c_bltsizh,
		c_bplcon0,c_bplcon1,c_bplcon2,c_bplcon3,c_bplcon4,c_clxcon,c_clxcon2,c_clxdat,c_bpl1mod,c_bpl2mod,
		c_bpl1pt,c_bpl2pt,c_bpl3pt,c_bpl4pt,c_bpl5pt,c_bpl6pt,c_bpl7pt,c_bpl8pt,
		c_spr1pt,c_spr2pt,c_spr3pt,c_spr4pt,c_spr5pt,c_spr6pt,c_spr7pt,c_spr8pt,
		c_color00,c_color01,c_color02,c_color03,c_color04,c_color05,c_color06,c_color07,c_color08,c_color09,
		c_color10,c_color11,c_color12,c_color13,c_color14,c_color15,c_color16,c_color17,c_color18,c_color19,
		c_color20,c_color21,c_color22,c_color23,c_color24,c_color25,c_color26,c_color27,c_color28,c_color29,
		c_color30,c_color31,
		c_aud0lc,c_aud0len,c_aud0per,c_aud0vol,c_aud0dat,c_aud1lc,c_aud1len,c_aud1per,c_aud1vol,c_aud1dat,
		c_aud2lc,c_aud2len,c_aud2per,c_aud2vol,c_aud2dat,c_aud3lc,c_aud3len,c_aud3per,c_aud3vol,c_aud3dat,
		c_lisaid,c_htotal,c_hsstop,c_hbstrt,c_hbstop,c_vtotal,c_vsstop,c_vbstrt,c_vbstop,c_sprhstrt,c_sprhstop,c_bplhstrt,
		c_bplhstop,c_hhpos,c_beamcon0,c_hsstrt,c_vsstrt,c_hcenter,c_diwhigh,c_bplhmod,c_sprhpt,c_bplhpt,c_fmode;

	if (win_cust) {
		get(win_cust,MUIA_Window_Open,&open);
		if (open)	set(win_cust,MUIA_Window_Open,FALSE);
		else		set(win_cust,MUIA_Window_Open,TRUE);
	} else {
		win_cust = WindowObject,
			MUIA_Window_Title, "More Custom",
			MUIA_Window_ID   , MAKE_ID('C','U','S','T'),
			WindowContents, HGroup,
				Child, VGroup,
				Child, HGroup, GroupFrameT("In/Output"), MUIA_Group_Columns, 2,
					Child, Label2("joy0dat:"), Child, c_joy0dat = TextObject, StringFrame, End,
					Child, Label2("joy1dat:"), Child, c_joy1dat = TextObject, StringFrame, End,
					Child, Label2("pot0dat:"), Child, c_pot0dat = TextObject, StringFrame, End,
					Child, Label2("pot1dat:"), Child, c_pot1dat = TextObject, StringFrame, End,
					Child, Label2("potgo:"), Child, c_potgo = StringHex4,
					Child, Label2("joytest:"), Child, c_joytest = StringHex4,
   					End,
				Child, HGroup, GroupFrameT("Disk"), MUIA_Group_Columns, 2,
					Child, Label2("adkcon:"), Child, c_adkcon = StringHex4,
					Child, Label2("dskbyt:"), Child, c_dskbyt = TextObject, StringFrame, End,
					Child, Label2("dskpt:"), Child, c_dskpt = StringHex8,
					Child, Label2("dsklen:"), Child, c_dsklen = StringHex4,
					Child, Label2("dsksync:"), Child, c_dsksync = StringHex4,
   					End,
				Child, HGroup, GroupFrameT("Blitter"), MUIA_Group_Columns, 2,
					Child, Label2("bltcon0:"), Child, c_bltcon0 = StringHex4,
					Child, Label2("bltcon1:"), Child, c_bltcon1 = StringHex4,
					Child, Label2("bltafwm:"), Child, c_bltafwm = StringHex4,
					Child, Label2("bltalwm:"), Child, c_bltalwm = StringHex4,
					Child, Label2("bltapt:"), Child, c_bltapt = StringHex8,
					Child, Label2("bltbpt:"), Child, c_bltbpt = StringHex8,
					Child, Label2("bltcpt:"), Child, c_bltcpt = StringHex8,
					Child, Label2("bltdpt:"), Child, c_bltdpt = StringHex8,
					Child, Label2("bltamod:"), Child, c_bltamod = StringHex4,
					Child, Label2("bltbmod:"), Child, c_bltbmod = StringHex4,
					Child, Label2("bltcmod:"), Child, c_bltcmod = StringHex4,
					Child, Label2("bltdmod:"), Child, c_bltdmod = StringHex4,
					Child, Label2("bltadat:"), Child, c_bltadat = StringHex4,
					Child, Label2("bltbdat:"), Child, c_bltbdat = StringHex4,
					Child, Label2("bltcdat:"), Child, c_bltcdat = StringHex4,
					Child, Label2("bltsize:"), Child, c_bltsize = TextObject, StringFrame, End,
					Child, Label2("bltsizv:"), Child, c_bltsizv = StringHex4,
					Child, Label2("bltsizh:"), Child, c_bltsizh = TextObject, StringFrame, End,
					End,
				End,
				Child, VGroup,
				Child, HGroup, GroupFrameT("Copper"), MUIA_Group_Columns, 2,
					Child, Label2("copcon:"), Child, c_copcon = StringHex4,
					Child, Label2("cop1lc:"), Child, c_cop1lc = StringHex8,
					Child, Label2("cop2lc:"), Child, c_cop2lc = StringHex8,
					Child, Label2("copjmp1:"), Child, c_copjmp1 = TextObject, StringFrame, End,
					Child, Label2("copjmp2:"), Child, c_copjmp2 = TextObject, StringFrame, End,
   					End,
				Child, HGroup, GroupFrameT("Raster"), MUIA_Group_Columns, 2,
					Child, Label2("vhpos:"), Child, c_vhpos = TextObject, StringFrame, End,
					Child, Label2("diwstrt:"), Child, c_diwstrt = StringHex4,
					Child, Label2("diwstop:"), Child, c_diwstop = StringHex4,
					Child, Label2("ddfstrt:"), Child, c_ddfstrt = StringHex4,
					Child, Label2("ddfstop:"), Child, c_ddfstop = StringHex4,
					Child, Label2("bplcon0:"), Child, c_bplcon0 = StringHex4,
					Child, Label2("bplcon1:"), Child, c_bplcon1 = StringHex4,
					Child, Label2("bplcon2:"), Child, c_bplcon2 = StringHex4,
					Child, Label2("bplcon3:"), Child, c_bplcon3 = StringHex4,
					Child, Label2("bplcon4:"), Child, c_bplcon4 = StringHex4,
					Child, Label2("clxcon:"), Child, c_clxcon = StringHex4,
					Child, Label2("clxcon2:"), Child, c_clxcon2 = StringHex4,
					Child, Label2("clxdat:"), Child, c_clxdat = TextObject, StringFrame, End,
					Child, Label2("bpl1mod:"), Child, c_bpl1mod = StringHex4,
					Child, Label2("bpl2mod:"), Child, c_bpl2mod = StringHex4,
					Child, Label2("bpl1pt:"), Child, c_bpl1pt = TextObject, StringFrame, End,
					Child, Label2("bpl2pt:"), Child, c_bpl2pt = TextObject, StringFrame, End,
					Child, Label2("bpl3pt:"), Child, c_bpl3pt = TextObject, StringFrame, End,
					Child, Label2("bpl4pt:"), Child, c_bpl4pt = TextObject, StringFrame, End,
					Child, Label2("bpl5pt:"), Child, c_bpl5pt = TextObject, StringFrame, End,
					Child, Label2("bpl6pt:"), Child, c_bpl6pt = TextObject, StringFrame, End,
					Child, Label2("bpl7pt:"), Child, c_bpl7pt = TextObject, StringFrame, End,
					Child, Label2("bpl8pt:"), Child, c_bpl8pt = TextObject, StringFrame, End,
					End,
				Child, HGroup, GroupFrameT("Serial"), MUIA_Group_Columns, 2,
					Child, Label2("serdat:"), Child, c_serdat = StringHex4,
					Child, Label2("serper:"), Child, c_serper = StringHex4,
   					End,
   				End,
				Child, HGroup, GroupFrameT("Color"), MUIA_Group_Columns, 2,
					Child, Label2("color00:"), Child, c_color00 = StringHex4,
					Child, Label2("color01:"), Child, c_color01 = StringHex4,
					Child, Label2("color02:"), Child, c_color02 = StringHex4,
					Child, Label2("color03:"), Child, c_color03 = StringHex4,
					Child, Label2("color04:"), Child, c_color04 = StringHex4,
					Child, Label2("color05:"), Child, c_color05 = StringHex4,
					Child, Label2("color06:"), Child, c_color06 = StringHex4,
					Child, Label2("color07:"), Child, c_color07 = StringHex4,
					Child, Label2("color08:"), Child, c_color08 = StringHex4,
					Child, Label2("color09:"), Child, c_color09 = StringHex4,
					Child, Label2("color10:"), Child, c_color10 = StringHex4,
					Child, Label2("color11:"), Child, c_color11 = StringHex4,
					Child, Label2("color12:"), Child, c_color12 = StringHex4,
					Child, Label2("color13:"), Child, c_color13 = StringHex4,
					Child, Label2("color14:"), Child, c_color14 = StringHex4,
					Child, Label2("color15:"), Child, c_color15 = StringHex4,
					Child, Label2("color16:"), Child, c_color16 = StringHex4,
					Child, Label2("color17:"), Child, c_color17 = StringHex4,
					Child, Label2("color18:"), Child, c_color18 = StringHex4,
					Child, Label2("color19:"), Child, c_color19 = StringHex4,
					Child, Label2("color20:"), Child, c_color20 = StringHex4,
					Child, Label2("color21:"), Child, c_color21 = StringHex4,
					Child, Label2("color22:"), Child, c_color22 = StringHex4,
					Child, Label2("color23:"), Child, c_color23 = StringHex4,
					Child, Label2("color24:"), Child, c_color24 = StringHex4,
					Child, Label2("color25:"), Child, c_color25 = StringHex4,
					Child, Label2("color26:"), Child, c_color26 = StringHex4,
					Child, Label2("color27:"), Child, c_color27 = StringHex4,
					Child, Label2("color28:"), Child, c_color28 = StringHex4,
					Child, Label2("color29:"), Child, c_color29 = StringHex4,
					Child, Label2("color30:"), Child, c_color30 = StringHex4,
					Child, Label2("color31:"), Child, c_color31 = StringHex4,
					End,
				Child, VGroup,
				Child, HGroup, GroupFrameT("Sprite"), MUIA_Group_Columns, 2,
					Child, Label2("spr1pt:"), Child, c_spr1pt = TextObject, StringFrame, End,
					Child, Label2("spr2pt:"), Child, c_spr2pt = TextObject, StringFrame, End,
					Child, Label2("spr3pt:"), Child, c_spr3pt = TextObject, StringFrame, End,
					Child, Label2("spr4pt:"), Child, c_spr4pt = TextObject, StringFrame, End,
					Child, Label2("spr5pt:"), Child, c_spr5pt = TextObject, StringFrame, End,
					Child, Label2("spr6pt:"), Child, c_spr6pt = TextObject, StringFrame, End,
					Child, Label2("spr7pt:"), Child, c_spr7pt = TextObject, StringFrame, End,
					Child, Label2("spr8pt:"), Child, c_spr8pt = TextObject, StringFrame, End,
					End,
				Child, HGroup, GroupFrameT("Audio"), MUIA_Group_Columns, 2,
					Child, Label2("aud0lc:"), Child, c_aud0lc = StringHex8,
					Child, Label2("aud0len:"), Child, c_aud0len = StringHex4,
					Child, Label2("aud0per:"), Child, c_aud0per = StringHex4,
					Child, Label2("aud0vol:"), Child, c_aud0vol = StringHex4,
					Child, Label2("aud0dat:"), Child, c_aud0dat = StringHex4,
					Child, Label2("aud1lc:"), Child, c_aud1lc = StringHex8,
					Child, Label2("aud1len:"), Child, c_aud1len = StringHex4,
					Child, Label2("aud1per:"), Child, c_aud1per = StringHex4,
					Child, Label2("aud1vol:"), Child, c_aud1vol = StringHex4,
					Child, Label2("aud1dat:"), Child, c_aud1dat = StringHex4,
					Child, Label2("aud2lc:"), Child, c_aud2lc = StringHex8,
					Child, Label2("aud2len:"), Child, c_aud2len = StringHex4,
					Child, Label2("aud2per:"), Child, c_aud2per = StringHex4,
					Child, Label2("aud2vol:"), Child, c_aud2vol = StringHex4,
					Child, Label2("aud2dat:"), Child, c_aud2dat = StringHex4,
					Child, Label2("aud3lc:"), Child, c_aud3lc = StringHex8,
					Child, Label2("aud3len:"), Child, c_aud3len = StringHex4,
					Child, Label2("aud3per:"), Child, c_aud3per = StringHex4,
					Child, Label2("aud3vol:"), Child, c_aud3vol = StringHex4,
					Child, Label2("aud3dat:"), Child, c_aud3dat = StringHex4,
					End,
				End,
				Child, HGroup, GroupFrameT("ECS/AGA"), MUIA_Group_Columns, 2,
					Child, Label2("lisaid:"), Child, c_lisaid = TextObject, StringFrame, End,
					Child, Label2("htotal:"), Child, c_htotal = TextObject, StringFrame, End,
					Child, Label2("hsstop:"), Child, c_hsstop = TextObject, StringFrame, End,
					Child, Label2("hbstrt:"), Child, c_hbstrt = TextObject, StringFrame, End,
					Child, Label2("hbstop:"), Child, c_hbstop = TextObject, StringFrame, End,
					Child, Label2("vtotal:"), Child, c_vtotal = TextObject, StringFrame, End,
					Child, Label2("vsstop:"), Child, c_vsstop = TextObject, StringFrame, End,
					Child, Label2("vbstrt:"), Child, c_vbstrt = TextObject, StringFrame, End,
					Child, Label2("vbstop:"), Child, c_vbstop = TextObject, StringFrame, End,
					Child, Label2("sprhstrt:"), Child, c_sprhstrt = TextObject, StringFrame, End,
					Child, Label2("sprhstop:"), Child, c_sprhstop = TextObject, StringFrame, End,
					Child, Label2("bplhstrt:"), Child, c_bplhstrt = TextObject, StringFrame, End,
					Child, Label2("bplhstop:"), Child, c_bplhstop = TextObject, StringFrame, End,
					Child, Label2("hhpos:"), Child, c_hhpos = TextObject, StringFrame, End,
					Child, Label2("beamcon0:"), Child, c_beamcon0 = TextObject, StringFrame, End,
					Child, Label2("hsstrt:"), Child, c_hsstrt = TextObject, StringFrame, End,
					Child, Label2("vsstrt:"), Child, c_vsstrt = TextObject, StringFrame, End,
					Child, Label2("hcenter:"), Child, c_hcenter = TextObject, StringFrame, End,
					Child, Label2("diwhigh:"), Child, c_diwhigh = TextObject, StringFrame, End,
					Child, Label2("bplhmod:"), Child, c_bplhmod = TextObject, StringFrame, End,
					Child, Label2("sprhpt:"), Child, c_sprhpt = TextObject, StringFrame, End,
					Child, Label2("bplhpt:"), Child, c_bplhpt = TextObject, StringFrame, End,
					Child, Label2("fmode:"), Child, c_fmode = TextObject, StringFrame, End,
					End,
				End,
			End;
		if (win_cust) {
			DoMethod(app,OM_ADDMEMBER,win_cust);
			sethex8t(c_vhpos,*((ULONG*)&(custom->wdcu_regs[2])));
			sethex4t(c_joy0dat,custom->wdcu_regs[5]);
			sethex4t(c_joy1dat,custom->wdcu_regs[6]);
			sethex4t(c_clxdat,custom->wdcu_regs[7]);
			sethex4(c_adkcon,custom->wdcu_regs[8]);
			sethex4t(c_pot0dat,custom->wdcu_regs[0x012/2]);
			sethex4t(c_pot1dat,custom->wdcu_regs[0x014/2]);
			sethex4(c_potgo,custom->wdcu_regs[0x016/2]);
			sethex4(c_serdat,custom->wdcu_regs[0x018/2]);
			sethex4(c_dskbyt,custom->wdcu_regs[0x01a/2]);
			if (custom->wdcu_flags[0x022].modi) sethex8(c_dskpt,*((ULONG*)&(custom->wdcu_regs[0x020/2])));
			if (custom->wdcu_flags[0x024].modi) sethex4(c_dsklen,custom->wdcu_regs[0x024/2]);
			if (custom->wdcu_flags[0x02e].modi) sethex4(c_copcon,custom->wdcu_regs[0x02e/2]);
			if (custom->wdcu_flags[0x030].modi) sethex4(c_serdat,custom->wdcu_regs[0x030/2]);
			if (custom->wdcu_flags[0x032].modi) sethex4(c_serper,custom->wdcu_regs[0x032/2]);
			if (custom->wdcu_flags[0x036].modi) sethex4(c_joytest,custom->wdcu_regs[0x036/2]);
			if (custom->wdcu_flags[0x040].modi) sethex4(c_bltcon0,custom->wdcu_regs[0x040/2]);
			if (custom->wdcu_flags[0x042].modi) sethex4(c_bltcon1,custom->wdcu_regs[0x042/2]);
			if (custom->wdcu_flags[0x044].modi) sethex4(c_bltafwm,custom->wdcu_regs[0x044/2]);
			if (custom->wdcu_flags[0x046].modi) sethex4(c_bltalwm,custom->wdcu_regs[0x046/2]);
			if (custom->wdcu_flags[0x048].modi) sethex8(c_bltcpt,*((ULONG*)&(custom->wdcu_regs[0x048/2])));
			if (custom->wdcu_flags[0x04c].modi) sethex8(c_bltbpt,*((ULONG*)&(custom->wdcu_regs[0x04c/2])));
			if (custom->wdcu_flags[0x050].modi) sethex8(c_bltapt,*((ULONG*)&(custom->wdcu_regs[0x050/2])));
			if (custom->wdcu_flags[0x054].modi) sethex8(c_bltdpt,*((ULONG*)&(custom->wdcu_regs[0x054/2])));
			if (custom->wdcu_flags[0x058].modi) sethex4t(c_bltsize,custom->wdcu_regs[0x058/2]);
			if (custom->wdcu_flags[0x05c].modi) sethex4(c_bltsizv,custom->wdcu_regs[0x05c/2]);
			if (custom->wdcu_flags[0x05e].modi) sethex4t(c_bltsizh,custom->wdcu_regs[0x05e/2]);
			if (custom->wdcu_flags[0x060].modi) sethex4(c_bltcmod,custom->wdcu_regs[0x060/2]);
			if (custom->wdcu_flags[0x062].modi) sethex4(c_bltbmod,custom->wdcu_regs[0x062/2]);
			if (custom->wdcu_flags[0x064].modi) sethex4(c_bltamod,custom->wdcu_regs[0x064/2]);
			if (custom->wdcu_flags[0x066].modi) sethex4(c_bltdmod,custom->wdcu_regs[0x066/2]);
			if (custom->wdcu_flags[0x070].modi) sethex4(c_bltcdat,custom->wdcu_regs[0x070/2]);
			if (custom->wdcu_flags[0x072].modi) sethex4(c_bltbdat,custom->wdcu_regs[0x072/2]);
			if (custom->wdcu_flags[0x074].modi) sethex4(c_bltadat,custom->wdcu_regs[0x074/2]);
			sethex4t(c_lisaid,custom->wdcu_regs[0x07c/2]);
			if (custom->wdcu_flags[0x07e].modi) sethex4(c_dsksync,custom->wdcu_regs[0x07e/2]);
			if (custom->wdcu_flags[0x082].modi) sethex8(c_cop1lc,*((ULONG*)&(custom->wdcu_regs[0x080/2])));
			if (custom->wdcu_flags[0x086].modi) sethex8(c_cop2lc,*((ULONG*)&(custom->wdcu_regs[0x084/2])));
			if (custom->wdcu_flags[0x088].modi) sethex4t(c_copjmp1,custom->wdcu_regs[0x088/2]);
			if (custom->wdcu_flags[0x08a].modi) sethex4t(c_copjmp2,custom->wdcu_regs[0x08a/2]);
			if (custom->wdcu_flags[0x08e].modi) sethex4(c_diwstrt,custom->wdcu_regs[0x08e/2]);
			if (custom->wdcu_flags[0x090].modi) sethex4(c_diwstop,custom->wdcu_regs[0x090/2]);
			if (custom->wdcu_flags[0x092].modi) sethex4(c_ddfstrt,custom->wdcu_regs[0x092/2]);
			if (custom->wdcu_flags[0x094].modi) sethex4(c_ddfstop,custom->wdcu_regs[0x094/2]);
			if (custom->wdcu_flags[0x098].modi) sethex4(c_clxcon,custom->wdcu_regs[0x098/2]);
			if (custom->wdcu_flags[0x0a2].modi) sethex8(c_aud0lc,*((ULONG*)&(custom->wdcu_regs[0x0a0/2])));
			if (custom->wdcu_flags[0x0a4].modi) sethex4(c_aud0len,custom->wdcu_regs[0x0a4/2]);
			if (custom->wdcu_flags[0x0a6].modi) sethex4(c_aud0per,custom->wdcu_regs[0x0a6/2]);
			if (custom->wdcu_flags[0x0a8].modi) sethex4(c_aud0vol,custom->wdcu_regs[0x0a8/2]);
			if (custom->wdcu_flags[0x0aa].modi) sethex4(c_aud0dat,custom->wdcu_regs[0x0aa/2]);
			if (custom->wdcu_flags[0x0b2].modi) sethex8(c_aud1lc,*((ULONG*)&(custom->wdcu_regs[0x0b0/2])));
			if (custom->wdcu_flags[0x0b4].modi) sethex4(c_aud1len,custom->wdcu_regs[0x0b4/2]);
			if (custom->wdcu_flags[0x0b6].modi) sethex4(c_aud1per,custom->wdcu_regs[0x0b6/2]);
			if (custom->wdcu_flags[0x0b8].modi) sethex4(c_aud1vol,custom->wdcu_regs[0x0b8/2]);
			if (custom->wdcu_flags[0x0ba].modi) sethex4(c_aud1dat,custom->wdcu_regs[0x0ba/2]);
			if (custom->wdcu_flags[0x0c2].modi) sethex8(c_aud2lc,*((ULONG*)&(custom->wdcu_regs[0x0c0/2])));
			if (custom->wdcu_flags[0x0c4].modi) sethex4(c_aud2len,custom->wdcu_regs[0x0c4/2]);
			if (custom->wdcu_flags[0x0c6].modi) sethex4(c_aud2per,custom->wdcu_regs[0x0c6/2]);
			if (custom->wdcu_flags[0x0c8].modi) sethex4(c_aud2vol,custom->wdcu_regs[0x0c8/2]);
			if (custom->wdcu_flags[0x0ca].modi) sethex4(c_aud2dat,custom->wdcu_regs[0x0ca/2]);
			if (custom->wdcu_flags[0x0d2].modi) sethex8(c_aud3lc,*((ULONG*)&(custom->wdcu_regs[0x0d0/2])));
			if (custom->wdcu_flags[0x0d4].modi) sethex4(c_aud3len,custom->wdcu_regs[0x0d4/2]);
			if (custom->wdcu_flags[0x0d6].modi) sethex4(c_aud3per,custom->wdcu_regs[0x0d6/2]);
			if (custom->wdcu_flags[0x0d8].modi) sethex4(c_aud3vol,custom->wdcu_regs[0x0d8/2]);
			if (custom->wdcu_flags[0x0da].modi) sethex4(c_aud3dat,custom->wdcu_regs[0x0da/2]);
#define set4(a,b) if (custom->wdcu_flags[a].modi) sethex4(b,custom->wdcu_regs[a/2]);
#define set4t(a,b) if (custom->wdcu_flags[a].modi) sethex4t(b,custom->wdcu_regs[a/2]);
#define set8(a,b) if (custom->wdcu_flags[a+2].modi) sethex8(b,*((ULONG*)&(custom->wdcu_regs[a/2])));
#define set8t(a,b) if (custom->wdcu_flags[a+2].modi) sethex8t(b,*((ULONG*)&(custom->wdcu_regs[a/2])));
			set8t(0x0e0,c_bpl1pt)
			set8t(0x0e4,c_bpl2pt)
			set8t(0x0e8,c_bpl3pt)
			set8t(0x0ec,c_bpl4pt)
			set8t(0x0f0,c_bpl5pt)
			set8t(0x0f4,c_bpl6pt)
			set8t(0x0f8,c_bpl7pt)
			set8t(0x0fc,c_bpl8pt)
			set4(0x0100,c_bplcon0)
			set4(0x0102,c_bplcon1)
			set4(0x0104,c_bplcon2)
			set4(0x0106,c_bplcon3)
			set4(0x0108,c_bpl1mod)
			set4(0x010a,c_bpl2mod)
			set4(0x010c,c_bplcon4)
			set4(0x010e,c_clxcon2)
			set8t(0x0120,c_spr1pt)
			set8t(0x0124,c_spr2pt)
			set8t(0x0128,c_spr3pt)
			set8t(0x012c,c_spr4pt)
			set8t(0x0130,c_spr5pt)
			set8t(0x0134,c_spr6pt)
			set8t(0x0138,c_spr7pt)
			set8t(0x013c,c_spr8pt)
			set4(0x0180,c_color00)
			set4(0x0182,c_color01)
			set4(0x0184,c_color02)
			set4(0x0186,c_color03)
			set4(0x0188,c_color04)
			set4(0x018a,c_color05)
			set4(0x018c,c_color06)
			set4(0x018e,c_color07)
			set4(0x0190,c_color08)
			set4(0x0192,c_color09)
			set4(0x0194,c_color10)
			set4(0x0196,c_color11)
			set4(0x0198,c_color12)
			set4(0x019a,c_color13)
			set4(0x019c,c_color14)
			set4(0x019e,c_color15)
			set4(0x01a0,c_color16)
			set4(0x01a2,c_color17)
			set4(0x01a4,c_color18)
			set4(0x01a6,c_color19)
			set4(0x01a8,c_color20)
			set4(0x01aa,c_color21)
			set4(0x01ac,c_color22)
			set4(0x01ae,c_color23)
			set4(0x01b0,c_color24)
			set4(0x01b2,c_color25)
			set4(0x01b4,c_color26)
			set4(0x01b6,c_color27)
			set4(0x01b8,c_color28)
			set4(0x01ba,c_color29)
			set4(0x01bc,c_color30)
			set4(0x01be,c_color31)
			set4t(0x01c0,c_htotal)
			set4t(0x01c2,c_hsstop)
			set4t(0x01c4,c_hbstrt)
			set4t(0x01c6,c_hbstop)
			set4t(0x01c8,c_vtotal)
			set4t(0x01ca,c_vsstop)
			set4t(0x01cc,c_vbstrt)
			set4t(0x01ce,c_vbstop)
			set4t(0x01d0,c_sprhstrt)
			set4t(0x01d2,c_sprhstop)
			set4t(0x01d4,c_bplhstrt)
			set4t(0x01d6,c_bplhstop)
			sethex4t(c_hhpos,custom->wdcu_regs[0x01da/2]);
			set4t(0x01dc,c_beamcon0)
			set4t(0x01de,c_hsstrt)
			set4t(0x01e0,c_vsstrt)
			set4t(0x01e2,c_hcenter)
			set4t(0x01e4,c_diwhigh)
			set4t(0x01e6,c_bplhmod)
			set8t(0x01e8,c_sprhpt)
			set8t(0x01ec,c_bplhpt)
			set4t(0x01fc,c_fmode)
			DoMethod(win_cust,MUIM_Notify,MUIA_Window_CloseRequest,TRUE,app,2,MUIM_Application_ReturnID,MAIN_MORECUST);
			set(win_cust,MUIA_Window_Open,TRUE);
		} else {
			MUI_Request(app,win,0,NULL,"Ok","Couldn't open Custom window.");
		}
	}
}

/****************************************************************************/

